// Copyright (C) 1991-2011 Altera Corporation
// Your use of Altera Corporation's design tools, logic functions
// and other software and tools, and its AMPP partner logic
// functions, and any output files from any of the foregoing
// (including device programming or simulation files), and any
// associated documentation or information are expressly subject
// to the terms and conditions of the Altera Program License
// Subscription Agreement, Altera MegaCore Function License
// Agreement, or other applicable license agreement, including,
// without limitation, that your use is for the sole purpose of
// programming logic devices manufactured by Altera and sold by
// Altera or its authorized distributors.  Please refer to the
// applicable agreement for further details.

// *****************************************************************************
// This file contains a Verilog test bench template that is freely editable to
// suit user's needs .Comments are provided in each section to help the user
// fill out necessary details.
// *****************************************************************************
// Generated on "01/04/2012 10:59:53"

// Verilog Test Bench template for design :ad7689.v 
//
// Simulation tool : ModelSim-Altera (Verilog)
//

`timescale 100 ps/ 10 ps
`include "ad7689_model.v"

module ad7689_tst();
// test vector input registers
reg adc_clk_i;
reg fpga_clk_i;
reg [15:0] data_i;
reg reset_i;
reg wr_data_n_i;

// wires
wire CNV_o;
wire MOSI_o;
wire SCLK_o;
wire [15:0]  data_o;
wire data_rd_ready_o;
wire data_wr_ready_o;
wire MISO_i;
//DEBUG wires
wire [5:0] model_state;
wire [10:0] driver_state;
wire sck_en;
wire [7:0] sck_counter;

localparam RWDC = 0;
localparam RWAC = 1;
localparam RWSC = 2;
localparam SPI_MODE = RWAC;

AD7699 #(
    .SPI_MODE(SPI_MODE)) 
   i1(
// port map - connection between master ports and signals/registers
	.CNV_o(CNV_o),
	.MISO_i(MISO_i),
	.MOSI_o(MOSI_o),
	.SCLK_o(SCLK_o),
	.adc_clk_i(adc_clk_i),
	.data_i(data_i),
	.data_rd_ready_o(data_rd_ready_o),
	.data_wr_ready_o(data_wr_ready_o),
	.fpga_clk_i(fpga_clk_i),
	.reset_i(reset_i),
	.wr_data_n_i(wr_data_n_i),
	.state_o(driver_state),
	.sck_en(sck_en)
);

//ADC Stub
ad7689_model #(
    .MODE(SPI_MODE)) 
    i2(
    .din_i(MOSI_o),
    .sck_i(SCLK_o),
    .cnv_i(CNV_o),
    .sdo_o(MISO_i),
    .state_o(model_state),
    .sck_counter(sck_counter)
);

initial
begin
    // Initialize the input signals
    adc_clk_i   = 0;
    fpga_clk_i  = 0;
    reset_i     = 0;
    data_i      = $random(); //???
    wr_data_n_i = 1;
    $display("Running testbench");
    #400;
      wr_data_n_i = 0;            // initiate convertion
    #50                           // keep the signal active atleast one clock cycle
      wr_data_n_i = 1;
end

// Clock generation - the clock should be 40 MHz
always
begin
    #125 
        adc_clk_i   = ~adc_clk_i;
        fpga_clk_i  = adc_clk_i;
end

endmodule

